<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Calendar"
	import="java.util.Locale"
	import="java.text.SimpleDateFormat"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

function goExport(preview)
{
	var frm = document.forms['reggie'];
	var url = 'Export.servlet?ID=<%=ID%>&cmd=ExportMonthlyOpList';
	url += '&time=' + frm.time.value;
	url += '&exportSubtype='+(frm.exportSubtype.checked ? 1 : 0);
	if (preview) 
	{
		var previewTitle = document.getElementById('previewTitle');
		var previewList = document.getElementById('previewList');
		
		Main.hide('previewWrapper');
		previewTitle.innerHTML = 'Working...';
		previewList.innerHTML = '';
		
		url += '&preview=1';
		var request = Ajax.getXmlHttpRequest();
		
		try
		{
			showLoadingAnimation('Working...');
			request.open("GET", url, false);	
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}

		if (request.status != 200)
		{
			Main.openPopup('', 'ErrorWindow', 800, 600);
			Main.getWindow('ErrorWindow').document.write(request.responseText);
		}
		else
		{
			var numLines = request.responseText.split('\n').length - 1;
			previewTitle.innerHTML = 'Operation dates - ' + frm.time[frm.time.selectedIndex].text + ' (' + numLines + ')';
			previewList.innerHTML = request.responseText;
			Main.show('previewWrapper');
		}
	}
	else
	{
		window.location = url;		
	}
	
}

</script>
<style>

.fullyear
{
	font-weight: bold;
}

#previewWrapper
{
	position: absolute;
	top: 9em;
	bottom: 1em;
	left: 20px;
	width: 850px;
	overflow: visible;
}

#previewList
{
	position: absolute;
	top: 1.5em;
	bottom: 0px;
	width: 950px;
	overflow: auto;
	
	white-space: pre; 
	font-family: monospace;
	border: 1px dotted #A0A0A0;
	border-radius: 4px;
	background: #E8E8E8;
	padding: 0.25em;
}

#previewTitle
{
	font-weight: bold;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Export monthly operation list" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the export but 
			it may no include all items.
		</div>
		<%
	}
	%>
	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Select month -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select month or year</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Month/Year</td>
				<td class="input">
					<select name="time">
					<%
					Calendar month = Calendar.getInstance(Locale.ENGLISH);
					DateFormatter monthly = new DateFormatter(new SimpleDateFormat("yyyy MMMM", Locale.ENGLISH));
					DateFormatter yearly = new DateFormatter(new SimpleDateFormat("yyyy", Locale.ENGLISH));
					int index = 0;
					while (month.get(Calendar.YEAR) > 2009)
					{
						%>
						<option value="<%=month.getTimeInMillis()%>" <%=index==1 ? "selected" : "" %>><%=monthly.format(month.getTime())%>
						<%
						if (month.get(Calendar.MONTH) == 0)
						{
							%>
							<option class="fullyear" value="-<%=month.getTimeInMillis()%>"><%=yearly.format(month.getTime()) %> (all)
							<%
						}
						index++;
						month.add(Calendar.MONTH, -1);
					}
					%>
					</select>
				</td>
				<td class="help"><span id="time.message" class="message" style="display: none;"></span></td>
			</tr>
			
			<tr>
				<td class="prompt">Optional columns</td>
				<td class="input">
					<input type="checkbox" name="exportSubtype" value="1" id="exportSubtype">
					<label for="exportSubtype">Specimen/NoSpecimen</label>
				</td>
				<td class="help"><span id="subtype.message" class="message" style="display: none;"></span></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gopreview" title="Preview" image="<%=home+"/images/export.png"%>" onclick="goExport(true)"/></td>
		<td><base:button id="goexport" title="Download" image="<%=home+"/images/download.png"%>" onclick="goExport(false)"/></td>
	</tr>
	</table>
	</form>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div id="previewWrapper" style="display: none;">
		<div id="previewTitle">Preview</div>
		<div id="previewList"></div>
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>